#!/usr/bin/perl -w
# por Diego.Saravia@gmail.com o dsa@unsa.edu.ar copyleft 2011 bajo la GPLv3+
#http://ac-archive.sourceforge.net/adl/stdrelpaths.html
#http://www.openismus.com/documents/linux/automake/automake


# en el caso de estar en el servidor detectarlo y usar el repo del servidor

# usar makefile pack para empaquetar!

#	print "TIPODES\n";

use strict;#
use Data::Dumper;
use Getopt::Long;
use YAML::Any qw(LoadFile);

$0 =~ m!/([^/]+)\s*$!;
my $progname = $1;
my $version=0.1;

$ENV{'PATH'}.=':/usr/local/bin'; # algunas distros, shell y usuarios no lo tienen

#TODO
#PATH BUSQUEDA
#DIR ESCRITURA
# que imprima todos los errores y luego salga
# busqueda texto progama 
#proxy LWP para wget
#verificar que no este instalado
#limpiar CACHE Y TMP

   #my $filels='';
   my $recuerdadirs={};
   my $recuerdafiles={};

   my $loginuser=getpwuid( $< );
   use File::HomeDir;
   my $fileSpec = File::HomeDir->my_home; 



my $settings={};
my ($arrayref, $string);
if (-e $fileSpec."/etc/simusol.yaml"){
    my ($settings,$arrayref, $string) = LoadFile($fileSpec."/etc/simusol.yaml");
    # no tiene sentido, es solo para configuracion del usuario o del admin, no del programador, o mantenedor.
    #}elsif (-e "/usr/local/etc/simusol.yaml"){
    #    my (%settings) = Load('/etc/simusol.yaml');
}elsif (-e "/etc/simusol.yaml"){
    print "etc \n";
    ($settings, $arrayref, $string) = LoadFile('/etc/simusol.yaml');
    print Dumper $settings, $arrayref, $string;
}




my $webserver="simusol.org";


if ($settings->{"webserver"}){
    $webserver=$settings->{"webserver"};
    #$webserver=~s/^\s+//;
    #$webserver=~s/\s+$//;
    print "si hay yaml >$webserver<\n";
    #my $server="simusol.ututo.org";
}




#PARA BAJAR
#my $simurl="http://$webserver/downloads";  NO
my $simurl="http://cssan.$webserver/pkgs";

# OJO EN SUMMA PUEDE HABER UN SERVER VIEJO, preveer

  # a veces wget , a veces LWP
  # cambio sin https (es publico)  y adentro de downloads para que sea mas facil replicar, se puso un link en el sitio g y en las replicas se sincroniza con -L

# SITIO INTERNO CSSAN  bajar y subir del sitio interno de cssan 
  my $cssanweb="https://cssan.$webserver";






   my $tipos={};
   $tipos->{RU}='/usr/share/simusol';
   $tipos->{RL}='/usr/local/share/simusol';
   $tipos->{RH}=$fileSpec.'/.simusol';

   my $server=0;
   my $prefix='';
   my $share='';
   my $pkgdir='';
   if($loginuser eq 'www-data'){
       $prefix='/var/simpack';
       $share='/var/simpack';
       $pkgdir='/var/simpack/pkgs';
       $server=1;
   }elsif($loginuser eq 'wwwrun'){
       $prefix='/srv/simpack';
       $share='/srv/simpack';
       $pkgdir='/srv/simpack/pkgs';
       $server=1;
   }elsif($loginuser eq 'root'){
	if (-d '/usr/share/simusol'){
            $prefix='/usr/share';
            $share=$prefix.'/simusol';
            $pkgdir="$share/pkg";   
	}elsif(-d '/usr/local/share/simusol'){
	    $prefix='/usr/local/share';
            $share=$prefix.'/simusol';
            $pkgdir="$share/pkg";      
        }else{
           print "Destino: No esta instalado simusol, creo los dirs\n";
            $prefix='/usr/local/share';
            $share=$prefix.'/simusol';
            $pkgdir="$share/pkg";      
	   }

    }else{
	if (-d "$fileSpec/.simusol"){
          $prefix=$fileSpec;
          $share=$prefix.'/.simusol';   
          $pkgdir="$share/pkg";   
	}else{
	    print "Destino: No esta instalado simusol, creo los dirs\n";
            $prefix=$fileSpec;
            $share=$prefix.'/.simusol';   
            $pkgdir="$share/pkg";  
            
        }
    }

print "PREFIX $prefix SHARE $share PKGDIR $pkgdir\n";
`mkdir -p $pkgdir`;
`mkdir -p $prefix`;
`mkdir -p $share`;

my $shareread=[];
#ver prefix!!!!
  my @share=($fileSpec.'/.simusol/var', '/usr/local/share/simusol/var', '/usr/share/simusol/var');
# luego le saco el var
  my @etc=($fileSpec.'/.simusol/etc/simpack.conf','/usr/local/share/simusol/etc/simpack.conf',
           '/usr/share/simusol/etc/simpack.conf', '/etc/simpack.conf');
  foreach my $shr (@share){
      my $esta=`ls -ld $shr 2>/dev/null`; #horrible -d no busca ocultos
      if ($esta=~/^d/){
          $shr=~s/\/var$//;
          if ($share eq ''){$share=$shr}
          $shareread=[@$shareread,$share];
          last;
          } 
      } 

  my $etcdata;
  #para PROXY
  foreach my $etcetera (reverse @etc){
      my $esta=`ls -l $etcetera 2>/dev/null`; #horrible -d no busca ocultos
      if ($esta=~/^-/){
      #if (-f $etcetera){
         open(DAT, $etcetera) || die("No puedo abrir $etcetera");
         $etcdata=[@$etcdata,<DAT>];  
         close(DAT);
         } 
      } 

  if (not $share){
      print "Simpack no esta correctamente instalado, baje el paquete\n";
      print "de http://$webserver/descargas/simpack.tgz,\n";
      print "descomprima y ejecute make\n";
      exit;
     }

my $paquetesdata="$pkgdir/paquetespedidos.data";

my $UNICODIR="";
my $APONER="";

use File::Find; #no funciona en eval
use File::Basename;


  eval {
       require File::Path;
       require Text::ASCIITable;
       require LWP::Simple;
       import File::Path;
       import Text::ASCIITable;
       import LWP::Simple;
       };
  if ($@) {
       print "Instale los modulos: File::Path, File::Find y Text::ASCIITable, con el comando:\n";
       print "   sudo cpan CPAN YAML\n";
       print "   sudo cpan  File::Path  File::Find Text::ASCIITable  LWP::Simple\n";
       exit;
       }

  # usa el comando externo tar, wget  y el install , comprobar

  #csan ya esta usado por programa s, se usa cssan




  my $unique={}; 
  my $installdata=[];
  my $uniquedata=[];

  my $basetmp="/tmp/simpack"; 
  `mkdir -p $basetmp`;
  `chmod -R 777 $basetmp`;
  
my $bajados=[];
  
  # var son datos del programa, no del usuario (data) 
  # pkg son los paquetes bajados
  # si nadie crea un /var en .simusol no pondra nada, el make crea uno en /usr/local
  # el paquete instalado en una distro crearia el /usr/share/simusol/var
  # hay que crear el .simusol/var para que el usuario local tenga su repo ahi
  # le make crea .simusol/var y pkg
  
# ls son archivos con la lista de archivos que simpack efectivamente instalo por cada paquete, es para remover.

#my @dirs=qw/data  docs  elements  models  pkg  projects  functions  var soft graphics other ls/;

#foreach (@dirs){
# `mkdir $share/$_ 2>/dev/null`;
#}

##################################################3

my $hagotest=0;
my $help=0;
my $mversion=0;
my $actualiza=0;

GetOptions('actualiza'=>\$actualiza, 'test' => \$hagotest, "help"  => \$help, "man" => \$help, "version" => \$mversion  ) or usage();
help() if  $help;
version() if  $mversion;

my $orden='h';
my $pack='';
my $destino;






#########
 ($orden,$pack,$destino)=@ARGV;
if (not $orden){$orden='h'};
 if (not defined $destino){$destino=''}

     if($orden eq 'h'){ ################################################################
                                                                          #Imprime ayuda
      help();
      exit;
 }elsif($orden eq 'v'){ ################################################################
                                                                        #Imprime version
      version();
      exit;
 }

if (scalar @ARGV <2 and $orden ne 'k' and $orden ne 'id' ){
     print "No hay argumentos suficientes\n";#: simpack [c|i] directorio|paquete\n c crear\n i instalar\n";
     usage();
     exit;
}else{
 # print "Programa: simpack\nOrden: $orden\nOrigen: $pack\nDestino: $destino\n";
 # print "simpack TEST: $hagotest, ORDER: $orden, ORIGEN: $pack, DESTINO: $destino\n";  
}

 if ($orden eq 'cp' or $orden eq 'mv' or $orden eq 'rm'){ ##############################
                                                          #Generica para origen, destino
      # cp mv rm
      # mover y no copiar es copiar y hacer un rm
      # ver copiar, remover, mover
      my $ismove=0;
      if ($orden eq 'mv'){$ismove=1}
      if ($orden eq 'rm'){$destino='RM'}
      if ($orden eq 'mv' and $destino eq 'RM'){} # listo,ya especificado
      if ($orden eq 'cp' and $destino eq 'RM'){ print "No hace nada\n"; exit}
      cp($pack,$destino,$hagotest,$ismove);

  }elsif($orden eq 'i'  ){ ##############################################################
                                                             #Baja e instala los paquetes
      cp("N:$pack","I",0,0);

  }elsif($orden eq 's'  ){ ##############################################################
                                  # baja todas las  .summa al repo local y busca paquetes
     
      # se recomienda  bajasummas();
      my $resultado=`cd  "$pkgdir" ; grep -r --include="*.summa" "$pack" .  `;
      if (not $resultado){
 	 my $summas= `cd $pkgdir/; ls *.summa| sed -e's/\.summa\$//'`;
         print "Ninguna coincidencia, paquetes existentes:\n$summas\n";
      }else{
        print "Resultado de la busqueda:\n$resultado\n";
      }
      # la primera keyword debe ser el nombre del paquete verificar!!

  }elsif($orden eq 'k'){ ################################################################
                                                       # Crear esqueleto de paquete vacio         

      if (-d "skeleton"){
          cp("N:skeleton","D:skeleton.vacio",0,0);  # poner P no N
      }else{
      cp("N:skeleton","D:skeleton",0,0);  # poner P no N
      }
#ver porque no anda
#      cp("N:skeleton","F",0,0);  # poner P no N

  }elsif($orden eq 't'){ ################################################################
                                                      #Prueba el paquete en el directorio
      if (-d $pack){
              test($pack,'');
	  }else{
              cp("F:$pack","TEST",0,0);
	  }

 }elsif ($orden eq 'c'){ ################################################################
                                       #Empaqueta; prueba el directorio y crea el paquete
     cp("D:$pack","F:",1,0);
 
 }elsif($orden eq 'il'  ){ ##############################################################
                                                               #Instala un paquete creado
     cp("F:$pack","I",0,0);
                                 
 }elsif ($orden eq 'r'){ ################################################################
                                                          #copia el paquete al repo local
     cp("F:$pack","R",0,0);

 
 }elsif($orden eq 'u'  ){ ##############################################################
               #Upload, sube y publica (si ok)  paquetes al servidor desde el repo local

     cp("R:$pack","N",0,0);
 
 }elsif($orden eq 'rms'){ ##############################################################
                                      # borra paquete del servidor (espacio del usuario)
     removerepo($pack);

 }elsif($orden eq 'rml'){ ##############################################################
                                                                     #Limpiar repo local
     if (not $server){
      File::Path::rmtree($pkgdir);
     }

 }elsif($orden eq 'rmt'){ ##############################################################
                                                 #Limpiar arbol de descompresion en /tmp
      File::Path::rmtree($basetmp);
     
 }elsif($orden eq 'id'  ){ ##############################################################
                                                                     #Procesa repo  local

                                 #Crea dependencias inversas en los summa del repo local
     creaideps($pkgdir,1);
                                                   # crea lasts si se dice de que paquete
     if(not $pack){$pack=''};
     my $elmaximoname='';
     my ($v,$t);
     if ($pack){   
       my ($pname,$v,$t)=split(/-/,$pack);
       my ($elmaximo)=maximo($pname,["$pkgdir"]);  # doble dir, es tonto         
       ($elmaximoname,$v,$t)=split(/-/,$elmaximo);
       if (defined $elmaximoname and $elmaximoname) {
          print "Nombre: $pname Maximo: $elmaximo - $elmaximoname\n";      
         `rm -f $pkgdir/$elmaximoname-last.s.tgz` ;
         `ln -s $pkgdir/$elmaximo.s.tgz  $pkgdir/$elmaximoname-last.s.tgz` ;
       }
     }else{
       my $listapkg={};
       opendir (DIR, $pkgdir) or die "No abrio directorio $pkgdir\n"; 
       while  (my $element=readdir(DIR)) { 
           if ($element eq '.' or $element eq '..' or $element eq '.svn'){
           next;
           }
           my ($pname,$ppath,$psuffix) = fileparse($element,"\.s\.tgz"); 
           my ($n,$v,$t)=split(/-/,$pname);
           if ($psuffix eq '.s.tgz' and $n){
              $listapkg->{$n}=1;
              } 
       }
       closedir DIR;
	 foreach $pack (keys %$listapkg){
             my ($elmaximo)=maximo($pack,[$pkgdir]);              
             print "Nombre: $pack Maximo: $elmaximo\n";                                                       
             ($elmaximoname,$v,$t)=split(/-/,$elmaximo);
             if (not $elmaximoname){$elmaximoname=''};
             if (not $v){$v=''};
             if (not $t){$t=''};
             `rm -f $pkgdir/$elmaximoname-last.s.tgz` ;
             `ln -s $pkgdir/$elmaximo.s.tgz  $pkgdir/$elmaximoname-last.s.tgz` ;
             }
     }
     
     print "Es Server?: $server\n";
     if (not $server){
         print "Baja summas\n";
         bajasummas();
     }

     
 }else { ###############################################################################
      print "Orden desconocida: $orden\n";
      exit; 
      } ################################################################################

exit;

#############################################################################################
sub removerepo{
    my ($pack)=@_;
   use HTTP::DAV;

   $ENV{'PERL_LWP_SSL_VERIFY_HOSTNAME'}=0; #poner antes del new!!!

   my $d = new HTTP::DAV;
   my $url ='';
   my $user='';
   my $pass='';
   my $entro=0;
   my $count=0;
   #HTTP::DAV::DebugLevel(3);

   while ($entro == 0 and $count++ <3){
     my ($user,$pass)= getuser();

     $url="https://$webserver/users/$user/upload";
     $d->credentials( -user=>$user,-pass =>$pass, 
                    -url =>$url); #     -realm=>"User" );

     if ($d->open( -url=>$url )){
	 $entro=1;
     } else {
         print "Incorrecto, $user no ingreso a $url\n";   
     }
  
   }
#($username, $encrypted) = ( getpwuid $< )[0,1];
   if ($entro){
      print "Por subir\n";  #siempre entra, antes decia entre
   } else{ 
      print "No entre\n";
      exit;
  }

      my $file="$url/$pack.s.tgz";

      if ( $d->delete( -url => $file ) ) {
         print "successfully deleted $file\n";
       }else{
         print "delete of $file failed: " . $d->message . "\n";
         }

}
#############################################################################################
sub getuser{
    my ($user,$pass);
     print "Ingrese usuario:";
     $user = <STDIN>;
     chomp $user;
     use Term::ReadKey;
     ReadMode('noecho');
     print "Ingrese pass:";
     $pass = ReadLine(0);
     chomp $pass;
     ReadMode('normal');
     print "\n";
  return ($user,$pass);
}

#############################################################################################

sub leepaquete{
  my @keydata;
  my $data={};
  my $ok=1;
  if (-e $paquetesdata){
      $ok=0;
      open FILE, $paquetesdata or die $!;
      $ok=1; # si no die 
      @keydata=<FILE>;  
      close(FILE);
      foreach my $linea (@keydata){
	 chomp $linea;
         my $int=[split(/:/,$linea)];
         #print "leepaquete",$linea,Dumper $int;
         $data->{$int->[0]}=$int;    
         }
  }
return ($ok,$data);
}
##########################################################################
sub agregapaquete{
  my ($paquete,$actualiza)=@_;

# agrega un paquete y actualiza todas sus dependencias 


     my @traidos=();
       my $resul=0;

#    print "datacod", Dumper $datacode;
    my $datec=`date`;
    chomp $datec;
    $datec=~s/:/./g;
       
     
  if (not $actualiza){
     my ($spdir,$ksname,$kversion,$ktipo)=detfile($paquete,'.s.tgz',
           [$tipos->{RH}.'/pkg',$tipos->{RL}.'/pkg',$tipos->{RU}.'/pkg'],0,'agrega paq');
     if ( -e "$spdir.s.tgz"){
     print "ESTA2 $spdir.s.tgz\n"; 
     return (2,["$spdir.s.tgz"]);
   }
  

  }
       my $visto={};
  
       my @atraersumma=($paquete);
     
       while(my $paq=shift @atraersumma){
          print "PAQ: $paq\n";
          if (not $visto->{$paq}){
          $visto->{$paq}=1;
          my ($bajo,$misuma,$jpath,$SUMMA_BASEVERSION,$SUMMA_SIMUSOLTYPE,
                     $SUMMA_CATEGORY,$SUMMA_DEPENDS,$SUMMA_IDEPENDS)=summa('',$paq,$actualiza);
          print "BAJO SUMMA, $bajo\n";
          if ($bajo==1){
            @traidos=(@traidos,"$misuma-$SUMMA_BASEVERSION-$SUMMA_SIMUSOLTYPE");  
	    my @ddd=split(/,/,$SUMMA_DEPENDS.','.$SUMMA_IDEPENDS);
	    #$deps->{$paq}=[@ddd];
            #print join (' x ',@ddd),"zzz \n";;
            @atraersumma=(@atraersumma,@ddd);
            # perl module Graph, salvarlo
            #$atraer=updeps($paq,$instalados);
            #@atraersumma=(@atraersumma,  split(/,/,$atraer));
            }
  
          }
       }
      
  my @atraer;

       print "Traidos: @traidos\n";
       foreach (@traidos){
	  $resul=1;
          print "Baja PAQ: $simurl/pkgs/$_.s.tgz   a $pkgdir/$_.s.tgz\n";
          if ($actualiza and -e "$pkgdir/$_.s.tgz"){
 	       print "Copia viejo si existe. \n";
              ` mv $pkgdir/$_.s.tgz  $pkgdir/$_.s.tgz.vie`;
          } 
          `wget -P  $pkgdir --no-check-certificate -c $simurl/pkgs/$_.s.tgz 2>/dev/null`;
          
           if (not -e "$pkgdir/$_.s.tgz"){
	       print "Error, no bajo $pkgdir/$_.s.tgz\n";
               $resul=0; 
           } else{
	       @atraer=(@atraer,"$pkgdir/$_.s.tgz");
          }         
          }
  return ($resul,\@atraer);

}

#############################################################################################
 
sub creapack{
# usar make del proyecto

                my ($apedir,$aponer)=@_;

               if (not $aponer){

   		 my $pack;
                 my ($bajo,$misuma,$jpath,$SUMMA_BASEVERSION,$SUMMA_SIMUSOLTYPE,$SUMMA_CATEGORY,$SUMMA_DEPENDS,$SUMMA_IDEPENDS)=summa($apedir);


                 $pack="$misuma-$SUMMA_BASEVERSION-$SUMMA_SIMUSOLTYPE";
                 $aponer="$pkgdir/$pack.s.tgz";
	         }
            
               my ($pname,$ppath,$psuffix) = fileparse($aponer,"\.s\.tgz"); 
               File::Path::rmtree("$basetmp/$pname");
               File::Path::mkpath("$basetmp/$pname");
               `chmod -R 777 $basetmp`;
               `rsync -av --exclude='*.svn*' --exclude='*/.*' $apedir/ $basetmp/$pname`;     
               print "tar --exclude .svn -C$basetmp/ -zcvf $aponer $pname \n";
               `tar --exclude .svn -C$basetmp -zcvf $aponer $pname`;
	return $aponer;
	      }
#############################################################################################
sub abrenue{
    my ($apedir)=@_;
          my ($pname,$ppath,$psuffix) = fileparse($apedir,"\.s\.tgz"); 
               File::Path::mkpath("$basetmp");
               `chmod -R 777 $basetmp`;
               # protesta porque no puede remover directorio corriente, ver
               File::Path::rmtree("$basetmp/$pname");
               print "tar -C $basetmp  -zxvf $apedir\n";    
              
               `tar -C $basetmp  -zxvf $apedir`;
               if(not -e "$basetmp/$pname"){
                 print "El paquete: $apedir no contiene lo que promete: $pname, 
                        limpie a mano el directorio $basetmp, no se lo que puso.\n";
	         exit;
                 } 

 return $pname;
}
############################################################################################
sub leels{

# revisar la direccion   basetmp.ls!!!!

 my ($file,$dir,$cpmvrm)=@_;
 if (not  $dir){
      $dir=$basetmp."ls"; # hacerlo al azar
     `rm -r $dir`;
     `mkdir $dir`; 
 }
 if (not -d $dir){
   print "no hay directorio $dir\n";
   exit;
   } 
   open FILE, $file or die $!;
   while (<FILE>) {
 	chomp;
	if (not $_){last;}
        if ($cpmvrm==2){
            print "rm $_\n";
	    `rm $_`;

        }elsif ($cpmvrm==1){
	    print "mv $_ $dir\n";
	    `mv $_ $dir`;

        }else{
	    print "cp $_ $dir\n";
	    `cp $_ $dir`;

        }
	return $dir;
   }
}
#############################################################################################
sub install{
    my ($dirpack,$aponer)=@_;  # a poner para que sirve????
    # si no hay simusol-make probar con make
     print "EJECUTA: simusol-make -C $dirpack installpack \n";
    `simusol-make -C $dirpack installpack`;

     #    exit;

}
#############################################################################################
sub archs{
  return qw/ChangeLog AUTHORS NEWS README INSTALL COPYING COPYING.WEB COPYING.DOC LICENSE THANKS TODO Makefile/;
}
#############################################################################################
sub dirs{
  return qw/projects data soft sheets shapes elements models docs graphics other objects functions pm aux/;
}

#############################################################################################
sub name{
    my ($pack)=@_;
    # pack
    my @nnn=split(/\//,$pack);
    return split(/-/,$nnn[-1]);
}

#############################################################################################
sub totest{

   my $file=$_;

   my $dirpack=$UNICODIR;

   my $gdir=$File::Find::dir;

   my $dir=$gdir;
   my $kdir="$dirpack/";
   $dir=~s/^$kdir//;

# revisar lo de index.html

   if ($file eq '.' or $file eq '..' or $file=~/\.svn/ or $dir=~/\.svn/ or $file eq "index.html"){
       return;
       }
   my $esdir=0;
   if (-d "$gdir/$file"){             
       $esdir=1;
       }
   # se recomienda usar nombres PAQUETE|PROYECTO-archivo.xx
   my $odir=$dir;
   my @paths=split('/',$dir);
   my $tdir=$paths[0];
   $odir=~s/^$tdir\///;
   print "FILE: $file DIRPACK $dirpack GDIR $gdir  DIR $dir  TDIR $tdir  ODIR $odir\n";

#   if ($odir=~s/(^shapes)\///){
#       $tdir='shapes';
#       
#       #print "QQQQQQQQQQQQQQQQQQQQQQQQQQQQQ $odir\n";
#   }else{
#       $odir='';
#   }

# sacar graphics, poner dia no principales

   my $ext={'projects'=>['(\.dia|\.d|\.ls3|\.caj|\.res|\.paraplot|\.simul|\.png|\.eps|\.graf|\.gnu|\.sim|\.gra)$'],
# los archivos diferentes al fuente dia, son en el caso que se quieran distribuir resultados a los efectos de hacer tests.
# el directorio projects puede tener subdirectorios en arbol
# tambien puede haber estos archivos en la raiz
# por defecto se ejecutara -si existe - el dia con el nombre del proyecto
         'data'=>['\.csv$','\.txt$','\.cua$'],
         'functions'=>['\.c$','\.for$'],
         'sheets'=>['\.sheet$'],
         'shapes'=>['\.shape$'],   # ojo aca hay xpm u otros, pero no nos interesan para unicos, mismo nombre
         'elements'=>['_ele\.dia$'],
         'objects'=>['\.dia$'],  # no se
         'aux'=>['\.dia$'],  # no se
         'pm'=>['\.pm$'],  # no se
         'models'=>['_mod\.dia$'],
         'docs'=>['\.[^\.]+$'],    # no puede haber dos documentos iguales en general en dif docs, en uno si
         'graphics'=>['\.[^\.]+$'],    # no puede haber dos documentos iguales en general
         'soft'=>['\.[^\.]+$'],    # no puede haber dos documentos iguales en general
         'other'=>['paqlog\.\d+\.html|\.[^\.]+$'],    # no puede haber dos documentos iguales en general
          };
   my $exts='';
   # ya no sirve mas la lista de extensiones de project
   if ($tdir eq 'projects'){
        print "SACA projects: $file - $tdir - $odir\n";
	if ($odir ne 'projects') {
             $exts=$file;
	      $file="";
        }elsif ($file=~s/(\.dia)$//){
             $exts=$1;
   	}else{
             $exts=$file;
	      $file="";
 	    }         
   }else {
    foreach my $cad (@{$ext->{$tdir}}){
         print "$file $cad\n";
         if ($file=~s/($cad)//){
             $exts=$1;
             next;
   	     }
         }
   }
   if ($tdir eq 'shapes' and not $exts and not $esdir ){
        return;    
        # son las graficas de las shapes #png, xpm etc ponerlas
   }

  if (not $exts and not $esdir ){
      print "Archivo no autorizado en paquete: $dir - $file - $exts - $esdir\n";
      #exit 1;
   }
   my $malclasi=0;
   if ($exts eq '.dia' or $exts eq '.shape' or $exts eq '.sheet'){
        #print "DDD $gdir/$file$exts\n";
        my $salida=`simusol_clasi $file$exts   `; 
        my $salcod=`echo -e "$salida" |grep codarch|tail -n1|awk '{print \$3}'|sed -e"s/[\',]//g"` ;
        chomp $salcod;
        my $salbueno=`echo -e "$salida" |grep bueno|tail -n1|awk '{print \$3}'|sed -e"s/[\',]//g"` ;
        chomp $salbueno;
	#print "TEST: $gdir/$file${exts}=$salcod,$salbueno.\n";
        if ($salcod eq 'dia'){$salbueno='yes'}
        if (not $exts eq '.'.$salcod or not $salbueno eq 'yes'){
	    print "ERROR, sale  -$exts-$salcod-  -$salbueno-yes-\n";
	    #	   exit;
            $malclasi=1;
        }
   }


   # revisar que todos los directorios sean sheets (al reves no), pueden estar en dependencias
   my $excluirres=1;
   foreach my $excl (qw(gnuplot\. tests tmps results aux data elements functions models results)){
       if ($file=~/$excl/){
         $excluirres=0;
       }
   } 
   if ($file and $excluirres){
      $unique->{lc($file)}=1;
   }
   #print "UNICO $esdir: $file, CONTENEDOR: $tdir EXT: $exts SHAPEDIR: $odir \n";
   $uniquedata=[@$uniquedata,[$esdir,$file,$tdir,$exts,$odir]];

}

#############################################################################################
sub test{
    my ($dirpack,$aponer)=@_;
    #$aponer='';
    # aponer esta mal, ver

    my ($bajo,$sname,$jpath,$version,$tipo,$SUMMA_CATEGORY,$SUMMA_DEPENDS,$SUMMA_IDEPENDS)=summa($dirpack);

#    print "$bajo,$sname,$jpath,$version,$tipo,$SUMMA_CATEGORY,$SUMMA_DEPENDS,$SUMMA_IDEPENDS\n";

#    exit;

    
    my $falta='';
    foreach (split(/,/,$SUMMA_DEPENDS)){
       my ($bajo1,$sname1,$jpath1,$version1,$tipo1,$SUMMA_CATEGORY1,$SUMMA_DEPENDS1,$SUMMA_IDEPENDS1)=summa('',$_);
       if ($bajo1 != 1){
           $falta.=$_.',';
            }
       } 
    if ($falta){
	print "No encuentro a los siguientes paquetes de las dependencias: $falta\n";
	exit 1;
    } elsif($SUMMA_DEPENDS)  {

         print "Las dependencias: $SUMMA_DEPENDS, estan satisfechas\n";
    }else{
         print "No define  dependencias\n";
     }  

    #my ($npd,$version,$tipo)=name($sname);
    my $ok=1;

    compruebapaqfull($sname,$version,$tipo,'TEST');

    print "Test -> Nombre: $sname\nVersion: $version\nTipo: $tipo\n";
   
   my @ARCHS=(archs(),"$sname.summa");
   foreach my $arch (@ARCHS){ 
   if (not -s "$dirpack/$arch"){
      print "MM $dirpack \n";
      print "Error. No hay archivo $arch, o esta vacio\n";
      $ok=0;
      exit 1;
      # comprobar que al menos exista un author com email valido
      # que copying sea la gplv3, ver hash
      # summa tenga nombre, version, depend, url de descarga
      # changelog sea correcto
      }
   }


# puse dirpack antes de archivos en elementes, sera que se ejecuta en otro dir, revisra que otras cosas cambian
   opendir (DIR, $dirpack) or die "No abrio directorio $dirpack -a\n";
   while  (my $element=readdir(DIR)) {
      if ($element eq '.' or $element eq '..' or $element eq '.svn'){
           next;
           }
      if ($element=~/\.(dia|d)$/){
           next;
           }
      my $esta=0;
      foreach my $modelo (dirs(),@ARCHS){
	  if ($element eq $modelo){
	      $esta=1;
          }
      }
      my $gelement=$element;
      $gelement=~s/\.graf$//;
      if (-e "$dirpack/$gelement".".dia" or -e  "$dirpack/$gelement".".d" ) {
	  $esta=1;
      }
      if (-d "$dirpack/$element" and (-e "$dirpack/$element".".dia" or -e  "$dirpack/$element".".d" ) ){
	   # existe un .dia llamado igual que el directorio
           # element es un proyecto en el paquete!!!
	   # revisar COMO TAL
	  revisaproyecto($element);
	  $esta=1;
      }
      if (not $esta){
         print "Error. El directorio: $dirpack contiene: $element, no esta previsto\n";
         $ok=0;
         exit 1;
      }
 
   }
   closedir (DIR);

    $unique->{lc($sname)}=1;

   my  @ndir=();
   foreach my $modelo (dirs()){
       if (-d  $dirpack."/".$modelo){
          @ndir=(@ndir, $dirpack."/".$modelo);
          }
       }
    $UNICODIR=$dirpack;
    $APONER=$aponer;
    #$filels='/tmp/tonto.ls';
    #my $premakefile='/tmp/premakefile';
    #`rm -f $filels`;
    $recuerdadirs={};
    $recuerdafiles={};
    my $rfil='';
    my $rdire='';
    File::Find::find(\&totest, @ndir);
  
    foreach my $fil (keys %$recuerdafiles){
	$rfil.=' '.$fil;
    }
    foreach my $dire (keys %$recuerdadirs){
	$rdire.=' '.$dire;
    }
   # `echo "dirstoinstall =$rdire">$premakefile`;
   # `echo "filestoinstall =$rfil">>$premakefile`;

   opendir (DIR, $dirpack) or die "No abrio directorio $dirpack -a\n";
   while  (my $element=readdir(DIR)) { 
       if ($element=~s/\.dia//){
      $unique->{lc($element)}=1;
      #print "UNICO $esdir: $file, CONTENEDOR: $tdir EXT: $exts SHAPEDIR: $odir \n";
      $uniquedata=[@$uniquedata,['',$element,'','.dia','']];
       }
   }

    my @listado=keys %$unique;
    foreach my $word (@listado){
	if (not $word=~m/^[a-z][a-z0-9_\-\.]*$/ ){
            # no espacios no eñes, ni nada
	    print "Error. Archivo usado: $word tiene nombre no permitido\n";
            #$ok=0;
            #exit 1;
        }
	if (length($word) > 100){
	    print "Error. Archivo usado: $word tiene mas de 100 letras\n";
            $ok=0;
            #exit 1;
        }
    }

    print "NOMBRES RESERVADOS\n";
    tableprint($uniquedata,['T','reservado','Contendor','Ext','shapedir']);
    
    print "PAQ: $ok; NOMBRES UNICOS USADOS A RESERVAR: ".join(',',@listado)."\n";

    my $listapal=join(',',@listado);
    my @nnn=split(/\//,$pack);
    my $fpack=$nnn[-1];

    my $path="$cssanweb/?action=-pp&palabras=$listapal&paquete=$fpack";
    #print "$path\n";
    #my $msg=LWP::Simple::get($path) or die "No funciona Internet";
    #print $msg;

    my $msg;

    $ENV{PERL_LWP_SSL_VERIFY_HOSTNAME}=0;
    my $ua = LWP::UserAgent->new;
    my $req = HTTP::Request->new(GET => $path);
    my $res = $ua->request($req);
    if ($res->is_success) {
       $msg=$res->as_string;
      
       use HTML::TagParser;
       my $html=HTML::TagParser->new($msg);
       my $elem = $html->getElementById( 'resultado' );
       if ($elem){
       #print "ELE:", $elem->innerText(),"\n";
       my ($llll,$reservadas)=split("Alguna Reservada: ", $elem->innerText());
   $reservadas=~s/(\d+)\s*,\s*//;
   my $hayreservadas=$1;
   
   my @malaspalabras;
   if ($hayreservadas){
         print "\nLista de palabras reservadas previamente que el paquete contiene:\n$reservadas\n";
         @malaspalabras=split(' ',$reservadas);


######### Habria que exit 1; aca!!!!!!!!!!!!!!!!!!

    }else{
	print "\nEl paquete no contiene palabras reservadas por otros paquetes\n";
    }
       }
  }
  else {
      print "No se pudo conectar al repo para verificar palabras, igual sigue: ", $res->status_line, "\n"; 
  }


# comprobar esto en el repo    

# verificar que mod sea mod, etc

# otro dir es tmp

return ($sname,$version,$tipo);

# extraer nombres de shapes y que no esten duplicadas
}
#############################################################################################
sub revisaproyecto{
    my ($proyecto)=@_;

#puede ser  /XXX o /projects/XXX

    return;
}


#############################################################################################

sub tableprint{
   my ($data,$enca)=@_;
     my $t = Text::ASCIITable->new();
     $t->setCols($enca);
     #     print Dumper $rr;
if (ref($data) eq "ARRAY"){
     my $cant= scalar @$data;
     print "Cant: $cant\n";
     foreach my $r (@$data){ # no se porque esto, debiera andar derecho
         $t->addRow($r);
         #print Dumper $r;
       }
     print $t;
}}

#############################################################################################

sub summa{
   my ($dir,$sname,$actualiza,$file)=@_;

   #print "SUMMA $dir,$sname,$actualiza,$file \n";

# ojo esto se queda con la version que esta, hacer algo para actualizar!!!!

# dir para un directorio donde debe buscar un summa
# sname para leerlos del repo local o bajarlos del repo de internet

   if (not $file){
       $file='';
   }

   my $misuma='';
   my $summavar;
   #my $continua=`cat ./readsumma.sh`; 
   my $string='';
   my $jpath='';

   if ($sname){
      my ($spdir,$kk,$kkk);
      ($spdir,$misuma,$kk,$kkk)=detfile($sname,'.summa',
                   [$tipos->{RH}.'/pkg',$tipos->{RL}.'/pkg',$tipos->{RU}.'/pkg'],0,'ORIGEN R');

      my ($jname,$jsuffix); 
      ($jname,$jpath,$jsuffix) = fileparse($spdir,""); 
      

      if (-e "$jpath$misuma.summa" and not $actualiza){
           print "SUMMA: $jpath$misuma.summa\n";
	   #print "RELEE $actualiza\n";
           $string=`cat $jpath$misuma.summa`; 
         }else{
           print "No encontre el paquete solicitado en esta maquina, busco en la red\n";
  	   my  $packsummastr;

           $ENV{PERL_LWP_SSL_VERIFY_HOSTNAME}=0;
           my $url=$simurl."/pkgs/${sname}.summa";
           print "A bajar : $url\n";            
           my $packsumma;
           my $ua = LWP::UserAgent->new;
           my $req = HTTP::Request->new(GET => $url);
           my $res = $ua->request($req);
           if ($res->is_success) {
                 $packsummastr=$res->as_string; # pone emcabezados
              
                  my $enca;
                  ($enca,$string)=split(/\n\n/,$packsummastr);
		  #print "STRING: $string\n";
                  open (CCC,">","$pkgdir/$misuma.summa") or die "No abrio $pkgdir/$misuma.summa\n";
                  print CCC $string;
                  close (CCC);
  		  $jpath=$pkgdir;
              }else{
                 print "Fallo conexion\n";
                 }
           }
    }elsif (-e $file){
           $string=`cat $file`;    
    }elsif($dir){
     $jpath=$dir;
     opendir (DIR, $dir) or die "No abrio directorio $dir -b\n";
     while  (my $element=readdir(DIR)) { 
      if ($element eq '.' or $element eq '..' or $element eq '.svn'){
           next;
      }elsif($element=~/([a-zA-Z][a-zA-Z0-9_]*)\.summa$/ and not $misuma){
               $misuma=$1;   
      }
     }

     if (not $misuma){
       print "No encontre .summa en $dir\n";
       exit 1;
       }
      $string=`cat $dir/$misuma.summa`; 

   }

   if ($string){



#use String::Interpolate qw( safe_interpolate interpolate ); 


       my $summadat=[split(/\n/,$string)];

#my $summadat=[];
#         open(DAT, "skeleton.ori/skeleton.summa") || die("No puedo abrir ");
#         $summadat=[@$summadat,<DAT>];  
#         close(DAT);
my $a;
my $alanterior=''; 
my $elanterior='';
my $tam=scalar @$summadat;
$tam--;
my $nuevodat=[];
my $i=0;
$nuevodat->[$i]=['NO_COMENTARIO_INICIAL',''];
#print "TAM $tam\n";
foreach (0..$tam){
 my $a='';
 my ($b,$v,$c);   
 #print "ww $i, $_, $summadat->[$_]\n";
    
    if ($summadat->[$_]=~/#/){
#	print "E\n";
     ($a,$b)=split(/#/,$summadat->[$_]);
     if (not $a) {$a=''}
     $a.="\n";
    }else{
	$a=$summadat->[$_];
    } 

    if ($a=~/=/){
      ($v,$c)=split(/=/,$a);
      $i++;
      $nuevodat->[$i]=[$v,$c];

    }else{
#	print "WWWWW $i - $nuevodat->[$i]->[1] - $a \n";
      $nuevodat->[$i]->[1].=$a;
    }
}

my $ddd={};
foreach (@$nuevodat){
    chomp $_->[1];
    my $tc='';
    if ($_->[1]=~s/^('|")//){
      $tc=$1;
      $_->[1]=~s/$tc$//;
      chomp  $_->[1];
    }
    $ddd->{$_->[0]}=$_->[1];

}
    #our $a=$_->[0];
#    my $b=$_->[1];
#    our $a=\$b;
#    ${$a}=$b;
#    print interpolate( $b  )," ZZZ \n";

#    print "$_->[0] : $_->[1] - ${$a}  - $tc\n";

#    our($GREET) = 'Hello'; # Cannot be lexical 
#    print interpolate( '$GREET $1\n', [ 'world' ] );
    


#print Dumper $nuevodat;




 #     $summavar=`eval $string$continua`;
 #     if (not $summavar){
 #       print "No pude leer correctamente $dir/$misuma.summa\n";
 #       exit;
 #       }

#homp $summavar;
#summavar=~s/^'//;
#summavar=~s/'$//;
#y (
my       $SUMMA_DEPENDS=$ddd->{DEPENDS};
my       $SUMMA_IDEPENDS=$ddd->{IDEPENDS};
my        $SUMMA_BASEVERSION=$ddd->{BASEVERSION};
my        $SUMMA_DESCRIPTION=$ddd->{DESCRIPTION};
my  $SUMMA_SUMMARY=$ddd->{SUMMARY};
my  $SUMMA_KEYWORDS=$ddd->{KEYWORDS};
my  $SUMMA_AUTHOR=$ddd->{AUTHOR};
my  $SUMMA_MAINTAINER=$ddd->{MAINTAINER};  
my  $SUMMA_VENDOR=$ddd->{VENDOR};
my  $SUMMA_PRIMATYSITE=$ddd->{PRIMARYSITE};
my  $SUMMA_SRC_URI=$ddd->{SRC_URI};
my  $SUMMA_SRC_PKG=$ddd->{SRC_PKG};
my  $SUMMA_SIMUSOLTYPE=$ddd->{SIMUSOLTYPE};
my  $SUMMA_CATEGORY=$ddd->{CATEGORY};
my  $SUMMA_SUMMAVERSION=$ddd->{SUMMAVERSION};
#=split(/','/,$summavar);

   if (not $SUMMA_BASEVERSION or not $SUMMA_SIMUSOLTYPE ){
        print "No esta bien conformado  $dir/$misuma.summa\n";
        exit 1;
   }


    #print "ZZMMM , $misuma,$SUMMA_BASEVERSION,$SUMMA_SIMUSOLTYPE,$SUMMA_CATEGORY,$SUMMA_DEPENDS,$SUMMA_DESCRIPTION\n";

    return (1,$misuma,$jpath,$SUMMA_BASEVERSION,$SUMMA_SIMUSOLTYPE,$SUMMA_CATEGORY,$SUMMA_DEPENDS,$SUMMA_IDEPENDS);
   }else{

       return -1;
   }

}

#############################################################################################

sub maximo{
my ($namepaquete,$refpath)=@_;
    my $maximo =0;
    my $elmaximo='';
    my $elmaximoname='';
    my $maxdir;
    my @lispath=@$refpath;
    foreach my $dir (@lispath){
     my $abrio=opendir (DIR,$dir ); # or print "No abrio directorio $dir\n";
     if ($abrio){
     while  (my $element=readdir(DIR)) { 
        my $ok=0;
        if ($element=~s/-(pro|mod|ele|other)\.s\.tgz$//){ $ok=1; $element.="-".$1};
           
        if ($element=~s/\.ls$//){ $ok=1};
        if ($element eq '.' or $element eq '..' or $element eq '.svn' or not $ok){
           next;
           }
        my $name='';
        my $v='';
        my $t='';
        ($name,$v,$t)=split(/-/,$element);
        if (not $name){$name=''};
        if (not $v){$v=''};
        if (not $t){$t=''};
        #print "      EZ $element - $name  - $v -$namepaquete \n";
        if ($name eq $namepaquete){ 
          #print "    EM $element - $name  - $v \n";
	  if (defined $v and $v ne "last"){
           my ($pn,$sn)=split(/\./,$v);
           $pn+=0; $sn+=0;
           if ($sn >=1000000){print "segundo numero de version es mas grande que el limite"; exit;};
           my $numver=1000000*$pn+$sn;
           if ($maximo <$numver){ $maximo=$numver; $elmaximo=$element; $elmaximoname=$name; $maxdir=$dir }
           }
	}}
        }
    }
    return($elmaximo,$maxdir);
}
#############################################################################################


sub procesaargorigen{
# debe definir en forma precisa donde esta la fuente, el comprueba y genera camino exacto
my ($oriname)=@_;

my ($tipoori,$camino)=split(/:/,$oriname);

my ($sname,$version,$tipo);
my $es;
my $apedir;
if ($tipoori eq 'D'){ #############################################3
    $es='DIR';
    if ($camino=~s/^TMP//){ # los TMP los genera el programa y deben ser perfectos
         my ($name,$path,$suffix) = fileparse($camino,"\.s\.tgz"); 
         #if ($name=~/\./) {
         #      print "Origen: el nombre de archivo/dir: $name tiene una extension no valida\n";
         #      exit;
         #      }
	 if ($suffix ne '' and $path ne './'){
	     print "Origen: Mal suffix o path deben ser vacios: $suffix, $path";
             exit;
         }
	 my $spdir;
        ($spdir,$sname,$version,$tipo)=detfile($name,'',["$basetmp/"],0,'ORIGEN Dir');
        my ($bajo,$jpath,$SUMMA_CATEGORY,$SUMMA_DEPENDS,$SUMMA_IDEPENDS);
        ($bajo,$sname,$jpath,$version,$tipo,$SUMMA_CATEGORY,$SUMMA_DEPENDS,$SUMMA_IDEPENDS)=summa($spdir);
       
        $apedir=$spdir
#"dir://".
   }elsif (not -d $camino){
	print "Origen: No existe directorio $camino\n";
        exit;
   }else{
     #my ($name,$path,$suffix) = fileparse($camino,"\.s\.tgz"); 
     #if ($name=~/\./) { es un dir puede tener lo que quiera
     #          print "Origen: El nombre de archivo/dir: $name tiene una extension no valida\n";
     #          exit;
     #          }
    my ($bajo,$jpath,$SUMMA_CATEGORY,$SUMMA_DEPENDS,$SUMMA_IDEPENDS);
    ($bajo,$sname,$jpath,$version,$tipo,$SUMMA_CATEGORY,$SUMMA_DEPENDS,$SUMMA_IDEPENDS)=summa($camino);

    # print "SUMMA $camino - $sname - $version - $tipo\n";
    #compruebapaqfull($sname,$version,$tipo); lo comprueba en el destino
    # y podria estar mal si el comando es para borrar o mover directorio
    #para mover directorios no importa que hay adentro es como el comando mv
    $apedir="$camino";
#dir://
   }
}elsif($tipoori eq 'F'){    #############################################3
    $es='PKG';
    my ($name,$path,$suffix) = fileparse($camino,"\.s\.tgz"); 
    #if ($name=~/\./) {
    #           print "Origen: El nombre de archivo/dir: $name tiene una extension no valida\n";
    #           exit;
    #           }
    my $spdir;
    ($spdir,$sname,$version,$tipo)=detfile($name,'.s.tgz',[$path],0,'ORIGEN F');
    if (not -e $spdir.'.s.tgz'){
	print "No existe el archivo:   $spdir.s.tgz\n";
        exit;
    }
#"file://".
    $apedir=$spdir.'.s.tgz';  


}elsif($tipoori=~/^R[ULH]/){ # es archivo sin path #############################################3
   $es='PKG';

   if (not -e "$tipos->{$tipoori}/pkg"){
        print "Origen: No existe repo pedido $tipoori\n";
        exit;
   } 
   my ($name,$path,$suffix) = fileparse($camino,"\.s\.tgz"); 
   if ($path ne './'){
     print "Origen: El archivo para el repo: $camino tiene tiene camino :$path\n"; 
     exit;
   }
   #if ($name=~/\./) { los name tienen punto por version
   #            print "Origen: El nombre de archivo/dir: $name tiene una extension no valida\n";
   #            exit;
   #            }
   #if ($suffix ne 's.tgz'){
   #	     print "Origen: Mal suffix: $suffix";
   #          exit;
   #}
   
    my $spdir;
    ($spdir,$sname,$version,$tipo)=detfile($name,'.s.tgz',[$tipos->{$tipoori}.'/pkg'],0,'ORIGEN RULH');
     if (not -e $spdir.'.s.tgz'){
	print "No existe el archivo:   $spdir.s.tgz\n";
        exit;
    }
#"file://".
    $apedir=$spdir.'.s.tgz';

}elsif( $tipoori eq 'R'){ #############################################3
     # buscar entre todos los repos el mas grande
     $es='PKG';
      my ($name,$path,$suffix) = fileparse($camino,"\.s\.tgz"); 
     if ($path ne './'){
       print "Origen: El archivo para el repo: $camino tiene tiene camino :$path\n"; 
       exit;
       }
     #if ($name=~/\./) {
     #          print "Origen: El nombre de archivo/dir: $name tiene una extension no valida\n";
     #          exit;
     #          }
     my $spdir;
     ($spdir,$sname,$version,$tipo)=detfile($name,'.s.tgz',[$tipos->{RH}.'/pkg',$tipos->{RL}.'/pkg',$tipos->{RU}.'/pkg'],0,'ORIGEN R');
   if (not -e $spdir.'.s.tgz'){
	print "No existe el archivo:   $spdir.s.tgz\n";
        exit;
    }
#"file://".
     $apedir=$spdir.'.s.tgz';
}elsif($tipoori eq 'N'){ # es archivo sin path #############################################3
   $es='N';
   my ($name,$path,$suffix) = fileparse($camino,"\.s\.tgz"); 
   if ($path ne './'){
     print "Origen: El archivo para el repo: $camino tiene tiene camino :$path\n"; 
     exit;
   }
   #if ($name=~/\./) {
   #            print "Origen: El nombre de archivo/dir: $name tiene una extension no valida\n";
   #            exit;
   #}   
   my $spdir;
   ($sname,$version,$tipo)=split(/-/,$name);  #ojo con last

   #($spdir,$sname,$version,$tipo)=detfile($name,'.s.tgz',["https://$webserver/pkgs"],1,'ORIGEN N');
   if (not $version or $version eq 'last'){ 
      $apedir="cssan://".$sname;#.'-last.s.tgz';
      $version="0.0"; 
      $tipo='A_DETERMINAR_AL_BAJAR';
      #print ">>>>>>>>>>>>>>>>>>>>>>> $name  $sname  $version <<<<<<<<<<<< \n";
   }else{
      my $nnombre=compruebapaqfull($sname,$version,$tipo,"Origen N");
      $apedir=$nnombre.'.s.tgz';
#"cssan://".
   }
   ### ver si esta!!!!
}elsif($tipoori eq 'I'){  #############################################3

# sera para paquetizar algo instalado o para desinstalar 
#usa un ls de un lugar especial

   # buscar entre todos los repos el mas grande
     $es='LS';
      my ($name,$path,$suffix) = fileparse($camino,"\.ls"); 
      if ($path ne './'){
       print "Origen LS: El archivo para el repo: $camino tiene tiene camino :$path\n"; 
       exit;
       }
      #if ($name=~/\./) {
      #          print "Origen: El nombre de archivo/dir: $name tiene una extension no valida\n";
      #          exit;
      #          }
      my $spdir;
      ($spdir,$sname,$version,$tipo)=detfile($name,'.ls',[$tipos->{RH}.'/ls',$tipos->{RL}.'/ls',$tipos->{RU}.'/ls'],0,'ORIGEN I');

      if (not -e $spdir.'.ls'){
	print "No existe el archivo:   $spdir.ls\n";
        exit;
    }
     $apedir=$spdir.'.ls';
#"file://".
     # se debe verificar que esto encontrado, esta instalado

}elsif($tipoori eq 'LS'){ #############################################3
# para algun ls hecho a mano
   $es='LS';
# listado de archivos instalados desde el directorio para ello
# ls con los mismos nombres que el paquete pero extension ls
# u otro listado
    my ($name,$path,$suffix) = fileparse($camino,"\.ls"); 
    #if ($name=~/\./) {
    #           print "Origen: El nombre de archivo/dir: $name tiene una extension no valida\n";
    #           exit;
    #           }
    my $spdir;
    ($spdir,$sname,$version,$tipo)=detfile($name,'.ls',[$path],0,'ORIGEN LS');

   if (not -e $spdir.'.ls'){
	print "No existe el archivo:   $spdir.ls\n";
        exit;
    }
    $apedir=$spdir.'.ls';  
#"file://".

}else{ #############################################3

    print "Origen: El tipo $tipoori de origen es incorrecto\n"; 
}


return ($es,$sname,$version,$tipo,$apedir);
}


#############################################################################################
sub procesaargdestino{
my ($dirdes,$sname,$version,$tipo)=@_;

#print "PAD $sname,$version,$tipo\n";

# destino debe decir donde quiere el paquete con precision, el comprueba y arma el camino exacto necesrio para ese fin.

my $aponer;
my ($tipodes,$camino)=split(/:/,$dirdes);
my $es;

if ($tipodes eq 'D'){ #############################################3
    $es='DIR';
    if ($camino eq 'TMP'){ # ultima parte de camino debe ser nombre de paquete


           my $nnombre=compruebapaqfull($sname,$version,$tipo,"Destino Dir");
#dir://
           $aponer="$basetmp/$nnombre";
    }elsif ($camino=~/^[\/]*TMP\//){ 
          print "Destino D: Probablemente se equivoco con el Path, para /tmp ponga D:TMP y nada mas\n";
          exit;  # y si no se equivoco???? y quiere un dir asi?
    }else{
      # crea el directorio $camino y adentro pone el paquete
      my ($name,$path,$suffix) = fileparse($camino); 
      if (not -d "$path"){
          print "Destino D: No existe el directorio previo: $path\n";
          exit;
          }
      # puede ser necesario crear el dir
      $aponer="$camino";
#dir://
    }
}elsif($tipodes eq 'F'){ #############################################3
      $es='PKG';
      my $nnombre=compruebapaqfull($sname,$version,$tipo,"Destino F");
       if ($camino and not -d $camino){
          print "Destino F: No existe el directorio para instalar: $camino \n";
          exit;

      }

      if ($camino){
      $camino=~s/\/$//;
      if ($camino){$camino.='/'};
      $camino=~s/^\.\///;
      }else{
        $camino=''
      }
# file://
      $aponer="$camino$nnombre.s.tgz";
}elsif($tipodes eq 'R'){ #############################################3
    $es='PKG';
    if ($camino){
          print "Destino: No debe indicarse un camino:$camino\n";
          exit;
      } 

    my $nnombre=compruebapaqfull($sname,$version,$tipo,"Destino R");

#file://
    $aponer="$pkgdir/$nnombre.s.tgz";

}elsif($tipodes eq 'N'){ #############################################3
    $es='N';
    if ($camino){
          print "Destino: No debe indicarse un camino:$camino\n";
          exit;
      }
   my $nnombre=compruebapaqfull($sname,$version,$tipo,"Destino N");
   $aponer="$nnombre.s.tgz"; # pedira usuario 
   # y el repo pondra el last
#cssan://


}elsif($tipodes eq 'LS'){  #############################################3
$es='LS';
# estos se colocan como files .ls donde se los pinden, cuando instala pone uno en un lugar especial
    my $nnombre=compruebapaqfull($sname,$version,$tipo,"Destino LS");
    if ($camino){
      if (not -d $camino){
          print "Destino: No existe el camino:$camino\n";
          exit;
       }else{
	$camino.='/';
        }
    }else{
	$camino='';
    }
#file://
    $aponer="$camino$nnombre.ls";
}elsif($tipodes eq 'I'){ # instalar en el sistema  #############################################3
     $es='I';
     # crea tambien un ls
     my $nnombre=compruebapaqfull($sname,$version,$tipo,"Destino I"); #solo para comprobar
     if ($camino){
          print "Destino: No debe indicarse un camino:$camino\n";
          exit;
      }
    # los paquetes simusol se instalan predominantemente en el share
    
     if ($prefix=~/^\/home/){
       $aponer="$prefix/.simusol";
     }else{
       $aponer="$prefix/simusol";
     }  

#install://
}elsif($tipodes eq 'TEST'){ # instalar en el sistema  #############################################3
    $aponer='TEST';
	 $es='TEST';
}elsif($tipodes eq 'RM'){ # instalar en el sistema  #############################################3
    $aponer='';
    $es='RM';
}else{
    print "Destino:  El tipo $tipodes es incorrecto\n"; 
exit;
}
return ($es,$aponer);
}


#############################################################################################
sub compruebapaq{
# no exije version o tipo
my ($npd,$version,$tipo)=@_;
      if (not $npd){$npd='';} 
      if (not $version){$version='';} 
      if (not $tipo){$tipo='';} 
      if (not $npd=~/[a-zA-Z][a-zA-Z0-9_]*/){
        print "Mal nombre: $npd\n";
        exit;
        }
      if ($version and (not $version=~/[0-9]+\.[0-9]+/ and not $version eq 'last')){
         print "Mal version $version\n";
         exit;
         }
      if ($tipo and not $tipo=~/^(ele|mod|pro|other|A_DETERMINAR_AL_BAJAR)$/){
         print "Mal tipo: $tipo\n";
         exit;
         }
  #  print "Nombre: $npd\nVersion: $version\nTipo: $tipo\n";
}

#############################################################################################

sub compruebapaqfull{
# no exije version o tipo
my $no=0;
my ($npd,$version,$tipo,$label)=@_;
      if (not $npd){
          $npd='';
          $no=1;
         } 
      if (not $version){
          $version='';
          $no=1;
         } 
      if (not $tipo){
          $tipo='';
          $no=1;
         }  
       if ($no){
	  print  "CPF $label: Falta alguno o mas. Name: $npd, Version: $version, Tipo:$tipo\n";
          exit;
          }
      if (not $npd=~/[a-zA-Z][a-zA-Z0-9_]*/){
        print "Mal nombre: $npd\n";
        exit;
        }
      if (not $version=~/[0-9]+\.[0-9]+/){
         print "Mal version $version\n";
         exit;
         }
      if (not $tipo=~/^(ele|mod|pro|other|A_DETERMINAR_AL_BAJAR)$/){
         print "Mal tipo: $tipo\n";
         exit;
         }
    my $nombre="$npd-$version-$tipo";
    #print "CPF $label  Nombre: $nombre\n";
return ($nombre);
}

#############################################################################################

# dado un camino y un nombre determina si hay paqute alli
#si el nombre es simple busca el last o el mayor completo
# devuelve camino completo al recurso sin extension
 
sub  detfile{

    my ($name,$suffix,$refpath,$net,$label)=@_;

# puesto sin pensar por un caso, revisar
$name=~s/\.s\.tgz$//;

   
    my @oripath=@$refpath; 
    my $maxdir='';
    # refpath puede tener varios directorios si se busca maximo.
    my ($sname,$version,$tipo)=split(/-/,$name);  #ojo con last
    compruebapaq($sname,$version,$tipo);
    my $apedir='';
    if ($sname eq $name){ # nombre puro
	if ($net){
	   if (scalar @$refpath != 1){print "Error mas de un dir en detfile\n"}
           $apedir=$refpath->[0]."/".$sname."-last";
           # en este caso el programa luego de bajar el paquete debe determinar el destino
           $version="0.0"; 
           $tipo='A_DETERMINAR_AL_BAJAR';
	}else{
           my ($elmaximo,$maxdir)=maximo($sname,$refpath); 
	   #print "Elmax $elmaximo - $maxdir - $sname - @$refpath \n";
           if ($elmaximo){
            ($sname,$version,$tipo)=split(/-/,$elmaximo); 
            if ($maxdir){
              $maxdir=~s/\/$//;
              if ($maxdir){$maxdir.='/'};
              $maxdir=~s/^\.\///;
             }else{
	      $maxdir='';
              }
             compruebapaqfull($sname,$version,$tipo,"DETFILE MAXIMUS $label");
             $apedir="$maxdir$elmaximo";
	   }else{
             $apedir=''; 
           }
	}
    }else{       
        $apedir='';
        my $nnombre=compruebapaqfull($sname,$version,$tipo,"DETFILE $label");
	while (not $apedir and scalar @$refpath>0 ){ 
	   
           my $path =shift @$refpath; 
           #print "CAMINO: $path\n";
           $path=~s/\/$//;
           if ($path){$path.='/'};
           $path=~s/^\.\///;
           if (-e "$path$nnombre$suffix"){
              $apedir="$path$nnombre";	  } 
           }
    }
    if (not $apedir){
                print "DETFILE $label: No encontre: $name en @oripath\n";

    }else{
                print "DETFILE $label REsult: $apedir\n" 

    }
    
return ($apedir,$sname,$version,$tipo);
}


#############################################################################################
sub subepack{
   my ($pack)=@_;
   my ($name,$zpath,$suffix) = fileparse($pack,"\.s\.tgz");
   use HTTP::DAV;
   #use Crypt::SSLeay;
   # para servidores con autocertificados
   $ENV{'PERL_LWP_SSL_VERIFY_HOSTNAME'}=0; #poner antes del new!!!
   #export PERL_LWP_SSL_VERIFY_HOSTNAME=0
   my $d = new HTTP::DAV;
   my $url ='';
   my $user='';
   my $pass='';
   my $entro=0;
   my $count=0;
   #HTTP::DAV::DebugLevel(3);

   if ($ENV{DISPLAY} and $ENV{ISSIMUSOLGUI}){

       print "Usando X y Simusol\n";
       
       my $userdata=<STDIN>; chomp $user;
       ($user,$pass)=split(/X067Xz/,$userdata);

       print "USER $user PASS xxx\n";

     $url="https://cssan.$webserver/users/$user/upload";

     $d->credentials( -user=>$user,-pass =>$pass, 
                    -url =>$url); #     -realm=>"User" );

     if ($d->open( -url=>$url )){
	 $entro=1;
     } else {
         print "Incorrecto, $user no ingreso a $url\n";   
     }

   }else{

   while ($entro == 0 and $count++ <3){
     ($user,$pass)= getuser();

     $url="https://cssan.$webserver/users/$user/upload";
     $d->credentials( -user=>$user,-pass =>$pass, 
                    -url =>$url); #     -realm=>"User" );

     if ($d->open( -url=>$url )){
	 $entro=1;
     } else {
         print "Incorrecto, $user no ingreso a $url\n";   
     }
  
   }#while
}# if simusolgui

   #($username, $encrypted) = ( getpwuid $< )[0,1];
   if ($entro){
      print "Proximo paso\n";  #siempre entra, antes decia entre
      #(la contraseña se verifica despues, al subir)\n";  #siempre entra, antes decia entre
   } else{ 
      print "No entre\n";
      exit;
  }
 
   if (-e $pack){
      if ( $d->put( -local => $pack, -url => $url ) ) {
         print "successfully uploaded  $pack to  $url/$name.s.tgz\n";
       }else{
         print "put to $url/$name.s.tgz failed: " . $d->message . "\n";
         exit;
       }
     }else{
       print "archivo $pack no encontrado \n";
       exit;
     }

    #   $d->unlock( -url => $url );
    my $path="$cssanweb/?action=-rp&user=$user&passwd=$pass&paquete=$name";
    #print "$path\n";
    my $msg;#=LWP::Simple::get($path) or die "No funciona Internet";
    #print $msg;
   $ENV{PERL_LWP_SSL_VERIFY_HOSTNAME}=0;
  use LWP::UserAgent;

  my $ua = LWP::UserAgent->new;
  my $req = HTTP::Request->new(GET => $path);
  my $res = $ua->request($req);
  if ($res->is_success) {
       $msg=$res->as_string;
  }
  else {

      print "No pudo conectarse al repo: $path, abandona: ", $res->status_line, "\n";
      die;
  }

   use HTML::TagParser;
   my $html=HTML::TagParser->new($msg);
   my $elem = $html->getElementById( 'resultado' );
   print "ELE:", $elem->innerText(),"\n";
}

#############################################################################################

sub copiadir{
my ($origen,$aponer)=@_; 
               File::Path::rmtree("$aponer");
               File::Path::mkpath("$aponer");
               `rsync -av $origen/ $aponer`;
}
#############################################################################################
sub usage{
#print "Usage:
#   simpack [OPCIONES] ORDEN PAQUETE\n";

use Pod::Usage;

#The desired level of "verboseness" to use when printing the usage message. If the corresponding value is 0, then only the "SYNOPSIS" section of the pod documentation is printed. If the corresponding value is 1, then the "SYNOPSIS" section, along with any section entitled "OPTIONS", "ARGUMENTS", or "OPTIONS AND ARGUMENTS" is printed. If the corresponding value is 2 or more then the entire manpage is printed.
my $message_text = "";
my $exit_status = 2; ## The exit status to use
my $verbose_level = 0; ## The verbose level to use
my $filehandle = \*STDERR; ## The filehandle to write to

pod2usage( { -message => $message_text ,
-exitval => $exit_status ,
-verbose => $verbose_level,
-output => $filehandle } );
}

#############################################################################################
sub help{
my $message_text = "";
my $exit_status = 2; ## The exit status to use
my $verbose_level = 1; ## The verbose level to use
my $filehandle = \*STDERR; ## The filehandle to write to

pod2usage( { -message => $message_text ,
-exitval => $exit_status ,
-verbose => $verbose_level,
-output => $filehandle } );

    usage();
}

#############################################################################################

sub version{
   print "\n      $progname  $version GPLV3+ diego.saravia\@gmail.com\n\n";
 
}
#############################################################################################

sub cp{

my ($pack,$destino,$hagotest,$ismove)=@_;

      if (not $destino){
	  print "No puedo copiar, no hay destino\n";
          exit;
      }

      # origen P, primero busca paquete en R y luego si no esta en el N, hoy N hace esto
      # origen Z, si hay red baja, si no se conforma con local

      my ($es,$sname,$version,$tipo,$apedir)=procesaargorigen($pack);
      my ($esd,$aponer)=procesaargdestino($destino,$sname,$version,$tipo);
      print "  COPIA=>  $es - $apedir, $esd - $aponer\n\n";
      if ($es eq 'DIR'){
        if ($hagotest or $esd eq 'TEST'){
           test($apedir,$aponer);
           if ($esd eq 'TEST'){exit}
           # aca poner test!
        } 
           if ($esd eq 'DIR'){
               # ver como excluir svn y otros 
               copiadir($apedir,$aponer); 
               #`cp -r $apedir/*  $aponer`;
           }elsif($esd eq 'PKG'){      
               creapack($apedir,$aponer);
        
               print "Creo el paquete $aponer \n";
           }elsif($esd eq 'LS'){

           }elsif($esd eq 'N'){                 
               # esto hace poner el paquete en los repos locales, estara bien?
               my $pack=creapack($apedir,'');
 	       subepack($pack);
           }elsif($esd eq 'I'){
	       print "Instala en $aponer\n";
	       install($apedir,$aponer);
           }
         if($esd eq 'RM' or $ismove){

           }
      }elsif($es eq 'PKG'){
          my $pname=abrenue($apedir);
          if ($hagotest or $esd eq 'TEST'){
	      #print "AQUI $pname\n";
              test("$basetmp/".$pname,'');
              if ($esd eq 'TEST'){exit}
              }
          if ($esd eq 'DIR'){
 	       copiadir("$basetmp/$pname",$aponer);
               print "Se desempaqueto el archivo $apedir al directorio $aponer\n";
           }elsif($esd eq 'PKG'){
	       if ($aponer eq $apedir){
                    print "Es una copia sobre si mismo, no lo hago\n";               
                    exit;
                  }    
	       `cp $apedir $aponer`;
               print "Copiado $apedir en $aponer \n";
           }elsif($esd eq 'LS'){

           }elsif($esd eq 'N'){
	       subepack($apedir);
           }elsif($esd eq 'I'){
               my $pname=abrenue($apedir);
               print "Instala $pname en $aponer\n";
	       install("$basetmp/$pname",$aponer);
	   }
         if($esd eq 'RM' or $ismove){

                
           }
      }elsif($es eq 'N'){

          $apedir=~s/^cssan:\/\///;
          $apedir=~s/-last.s.tgz$//;
          

#  my ($ok,$instalados)=leepaquete();
     #  if (not ref($instalados->{$paquete})){
     #  este no instala, asi que no controlar aqui eso
     #  if (not -e $paquetesdata){
     #    `touch $paquetesdata`;
     #    }   
     #  open FILE, '>>',$paquetesdata or die $!; 
     #  print FILE  "$paquete:$datec\n";
     #  close(FILE);
     #if (ref($instalados->{$paquete})){
     #  print "Paquete $paquete ya instalado\n";  
     #  return (2,[],$paquete);
     #}

    #  if ($actualiza == 2 ){
    #     @atraersumma=(@atraersumma, keys %$instalados);
    #     }
#y dependidos
# o actualiza todo lo pedido (pueden quedar paquetes no actualizados que ya nadie pidio y de los que no dependen nadie pedido)
  
          print "Agregapaq $apedir - $actualiza\n";
          my ($resul,$traidos)=agregapaquete($apedir,$actualiza);
          #print "WW $apedir ,  @$traidos , $resul\n";
          if ($resul != 2 and $resul !=1){

              # 2: ya esta
              # 1: bajo paquetes
	      #No pudo proceder error
              print "No pudo hacer lo solicitado, error\n";
              exit;
           }

           my $pname;	
          if ($esd eq 'DIR'){
	      my $traido=$traidos->[0];
              print "A ABRIR: $traido\n";
              $pname=abrenue($traido);
                                 
                    #    print "Descomprimio en $pname\n";    
                        if ($hagotest or $esd eq 'TEST'){
                                 test("$basetmp/$apedir",$aponer);
                                 }
                   #     print "Instala $pname en $aponer\n";
	           #     install("$basetmp/$pname",$aponer);
		  
 	       copiadir("$basetmp/$pname",$aponer);
               print "Se desempaqueto el archivo $apedir al directorio $aponer\n";   
          
           }elsif($esd eq 'PKG'){
	       $apedir="$pkgdir/$apedir.s.tgz";
	       `cp $apedir $aponer`;
               print "Copiado $apedir en $aponer \n";
           }elsif($esd eq 'I'){
                foreach (@$traidos){
	                print "A ABRIR: $_\n";
                        $pname=abrenue($_);         
                        print "Descomprimio en $basetmp/$pname\n";    
                        if ($hagotest or $esd eq 'TEST'){
                                 test("$basetmp/$apedir",$aponer);
                                 }
                        print "Instala (1)  $pname en $aponer  basetmp:$basetmp\n";
	                install("$basetmp/$pname",$aponer);
		  }
              
           }elsif($esd eq 'LS'){ print "traidos @$traidos  \n";
	          foreach (@$traidos){
	                print "A ABRIR: $_\n";
                        $pname=abrenue($_);         
                        print "Descomprimio en $basetmp/$pname\n";    
                        if ($hagotest or $esd eq 'TEST'){
                                 test("$basetmp/$apedir",$aponer);
                                 }
                        print "Instala $pname en $aponer\n";
	                install("$basetmp/$pname",$aponer);
		  }
	   }
         if($esd eq 'RM' or $ismove){
	       removerepo($apedir);
                 # solo del espacio del usuario

           }
      }elsif($es eq 'LS'){

         if ($esd eq 'DIR'  or $esd eq 'TEST'){
               $apedir=leels($apedir,$aponer,1);
               if ($hagotest){
                   test("$basetmp/$aponer",$aponer);
                   if ($esd eq 'TEST'){exit}
                   }
               # ver como excluir svn y otros 
               #copiadir($apedir,$aponer); 
               #`cp -r $apedir/*  $aponer`;
           }elsif($esd eq 'PKG'){      
               $apedir=leels($apedir,"",1);
               if ($hagotest){
                       test("$basetmp/$apedir",$aponer);
           # aca poner test!
                }
               creapack($apedir,$aponer);
               print "Creo el paquete $aponer \n";
           }elsif($esd eq 'LS'){

                 if ($aponer eq $apedir){
                    print "Es una copia sobre si mismo, no lo hago\n";               
                    exit;
                  }
                 if ($hagotest){
                    # hay que copiar a dir    test("/tmp/$apedir",$aponer);
                       # aca poner test!
                   }
    
	       `cp $apedir $aponer`;
               print "Copiado $apedir en $aponer \n";
           }elsif($esd eq 'N'){                 
               # esto hace poner el paquete en los repos locales, estara bien?
               $apedir=leels($apedir,"",1);
               if ($hagotest){
                    test("$basetmp/$apedir",$aponer);
                    }

	       my $apedir2="$pkgdir/$apedir.s.tgz";
               my $pack=creapack($apedir,$apedir2);
 	       subepack($pack);
           }elsif($esd eq 'I'){
               print "Por Instalar $apedir\n";
               $apedir=leels($apedir,"",1); #############################3 1?
               if ($hagotest){
                    test("$basetmp/$apedir",$aponer);
                    # aca poner test!
                    }
	       print "Instala en $aponer\n";
	       install($apedir,$aponer);
           }
         if($esd eq 'RM' or $ismove){

               $apedir=leels($apedir,"",0);
           }
      elsif ($es eq 'I'){
	  if ($esd eq 'DIR' or $esd eq 'TEST'){
               $apedir=leels($apedir,$aponer,1);
               if ($hagotest){
                   test("$basetmp/$aponer",$aponer);
                   if ($esd eq 'TEST'){exit}
                    # aca poner test!
                    }
               # ver como excluir svn y otros 
               #copiadir($apedir,$aponer); 
               #`cp -r $apedir/*  $aponer`;
           }elsif($esd eq 'PKG'){      
               $apedir=leels($apedir,"",1);
               if ($hagotest){
            test("$basetmp/$apedir",$aponer);
                    # aca poner test!
                    }
               creapack($apedir,$aponer);
               print "Creo el paquete $aponer \n";
           }elsif($esd eq 'LS'){
# como test?
	       if ($aponer eq $apedir){
                    print "Es una copia sobre si mismo, no lo hago\n";               
                    exit;
                  }    
	       `cp $apedir $aponer`;
               print "Copiado $apedir en $aponer \n";
           }elsif($esd eq 'N'){                 
               # esto hace poner el paquete en los repos locales, estara bien?
               $apedir=leels($apedir,"",1);
               if ($hagotest){
            test("$basetmp/$apedir",$aponer);
                    # aca poner test!
                    }
	       my $apedir2="$pkgdir/$apedir.s.tgz";
               my $pack=creapack($apedir,$apedir2);
 	       subepack($pack);
           }elsif($esd eq 'I'){
	       print "No tiene sentido autoinstalarse\n";
           }
         if($esd eq 'RM' or $ismove){
               leels("$share/ls/$apedir.ls","",0);
           }
           # I que no va para devnull es lo mismo que LS
      }
      }
}
#############################################################################################

sub bajasummas{

#print "wget  -r -nd  --accept .summa -P $pkgdir --no-check-certificate -c $simurl/pkgs/ 2>/dev/null";

my $sal=`wget  -r -nd  --accept .summa -P $pkgdir --no-check-certificate -c $simurl/pkgs/ 2>/dev/null`;

print "$sal\n";
}
#############################################################################################
sub creaideps{
# solo se debe ejecutar en el servidor, en su repo
   my ($dir,$reescribe)=@_;
 
   print "IDEPS $dir - $reescribe\n";
   my $recomienza=1;
   my @listado=();
   my $cita={};
   my $citados={};

   while ($recomienza){
     $cita={};
     $citados={};
     @listado=();
     my $nlistado={};
       $recomienza=0;
     opendir (DIR, $dir) or die "No abrio directorio $dir\n";
     while  (my $element=readdir(DIR)) { 
      if ($element eq '.' or $element eq '..' or $element eq '.svn'){
           next;
       }elsif($element=~s/\.summa$//){
           @listado=(@listado,$element);
           $nlistado->{$element}=1;        
           }
     }
   
     my @listado1=@listado;  
     while (my $element=shift @listado1){
          my ($bajo,$misuma,$jpath,$SUMMA_BASEVERSION,$SUMMA_SIMUSOLTYPE,
                     $SUMMA_CATEGORY,$SUMMA_DEPENDS,$SUMMA_IDEPENDS)=summa('','','',$dir.'/'.$element.".summa");
          print "SUMMA: $dir/$element, $bajo\n";
          if (not $SUMMA_DEPENDS){$SUMMA_DEPENDS='';}
          if (not $SUMMA_IDEPENDS){$SUMMA_IDEPENDS='';}
          print "DEPENDS: $SUMMA_DEPENDS\n";
          print "IDEPENDS: $SUMMA_IDEPENDS\n";
          if ($bajo==1){
	      foreach my $cit (split(/,/,$SUMMA_DEPENDS)){
                  if (not $nlistado->{$cit}){
                          # no tenemos la summa de esa dependencia
                          my ($bajo,$misuma,$jpath,$SUMMA_BASEVERSION,$SUMMA_SIMUSOLTYPE,
                                $SUMMA_CATEGORY,$SUMMA_DEPENDS,$SUMMA_IDEPENDS)=summa('',$cit,'','');
                          if ($bajo==1 and $jpath){
                              if ($reescribe){
                  	         `cp  $jpath$cit.summa $dir`; 
                                 }
                              $recomienza=1;
                              print "RECOMIENZO, ya baje la que faltaba: $jpath$cit.summa ";
                          }else{
                              print "El paquete:$element contiene una dependencia: $cit cuya summa no enuentro";
                              return 0;
                          }
                  }
		  $citados->{$cit}->{$element}=1;
		  $cita->{$element}->{$cit}=1;
	      }
 
	  }
   }
  }

# las ideps no se testean, porque las crea el repo, al crear el paquete no estan, solo al 
# subirse al repo aparecen, por ende esta rutina habilitada por reescribe solo se ejecuta
# en el servidor al subir el paquete, y solo afectaria a los otros paquetes citados por el que se sube

   if ($reescribe){
     while (my $element=shift @listado){
        print "ReGenerando summa $element\n";
        my @ideps=();
        my $idepends='';
	foreach (keys %{$citados->{$element}}){
	    @ideps=(@ideps,$_);
	}
        $idepends=join(',',@ideps);
        print "INFO IDEPENDS=\"$idepends\"\n";
        my $nuevasumma=`cat $dir/$element.summa | grep -v "IDEPENDS="`;  
        chomp $nuevasumma;
        chomp $nuevasumma;
        $nuevasumma.="\nIDEPENDS=\"$idepends\"\n";

        #print "=============== $element ====================\n";
        #$nuevasumma=~s/\'/\\\'/g;
        #print $nuevasumma, "\n";
        #`echo '$nuevasumma' >  $dir/$element.summa`;
        open(DAT,  ">$dir/$element.summa") || die("No puedo abrir $dir/$element.summa");
  	print DAT $nuevasumma;
        close(DAT);
    }
   }
   return 1;
}
__END__

=head1 NAME

simpack - administra paquetes de simusol


=head1 SYNOPSIS

B<simpack> [OPCIONES] ORDEN PAQUETE

=head1 Arguments

      Ordenes
          h: ayuda;   v: version
         Usuarios
          i: baja e instala (o actualiza) el paquete y sus dependencias 
               simpack i PAQUETE
          s: busca un paquete
               simpack s PAQUETE
         Desarrolladores
          k: crea esqueleto de paquete  bajo el directorio ./skeleton
          t: prueba 
          c: empaqueta
              simpack -c DIR  (busca alli un .summa)
         il: instala el paquete tomandolo del directorio indicado
          r:  copia paquete del directorio local / nombre indicado al cache o repositorio local de paquetes  
          u: sube paquetes desde el repo local al servidor, quien los comprueba y eventualmente publica
        rms: elimina archivos del servidor (directorio upload de cada desarrollador)
        rml: elimina paquetes del repo local (cache)
        rmt: elimina directorios de expansion
         id: baja summas para permitir busquedas,  crea dependencias inversas (IDEPENDS) en archivos SUMMA
   cp,mv,rm: funcion generica copia/move/remove ORIGEN DESTINO
  
=head1 Options

 -h --help: help  -v --version: version
 -t --test, prueba. (no hace falta indicarla con la orden c)
 -a --actualiza, aunque un paquete ya esta, lo baja e instala de nuevo en su ultima version  (o en la misma)

=head1 Otros

  Con dave se puede subir y bajar archivos del directorio upload de cada usuario.
     
  Los paquetes bajados no son testeados, se testean al subir.

PKG para leer (en ese orden): @$shareread
PKG para escribir: $share

B<simpack> [I<opciones>]  [I<orden>] [I<paquete>]

I<Opciones para obtener información sobre B<simusol>:> B<-help -version>

I<Opciones para modificar la información de ayuda durante la ejecución>:
B<--test>

=head1 AUTHORS

Diego Saravia <dsa@unsa.edu.ar> 
